import scg.ac.ni.pmf.newgraph.generator.GraphGenerator;
import scg.ac.ni.pmf.newgraph.graphdata.Graph;
import scg.ac.ni.pmf.newgraph.param.Parametrizable;
import java.util.Random;

public class RandomGraph2 implements GraphGenerator, Parametrizable {

        public String getName() {
                return "Random graph";
        }

        public String getDescription() {
                return "Random graph with given number of vertices and edge probability.";
        }

        public void newGraph(Graph graph) {
                int[][] a = new int[n][n];
                 //double radius = 200.0;
                // for (int i=1; i<=n; i++)
                 //    graph.createVertex (radius*Math.sin(2*Math.PI*i/n),
                  //                          radius*Math.cos(2*Math.PI*i/n));
                
                
                Random rnd = new Random();
                for (int i=0; i<n; i++)
                    for (int j=0; j<n; j++)
                              if(rnd.nextDouble() < p) {
                                    a[i][j] = 1;
                                    a[j][i] = 1;
                              } else {
                                  a[i][j] = 0;
                                  a[j][i] = 0;
                              }
                
                graph.create(a);
                        //if ( rnd.nextDouble() < p )
                        //    graph.createEdge(i,j);
        }

        private int n;
        public int getN() {
                return n;
        }
        public void setN(int n) {
                this.n = n;
        }

        private double p;
        public double getP() {
                return p;
        }
        public void setP(double p) {
                this.p = p;
        }
        
        public String checkParameters() {
                if (n<1) 
                    return "The number of vertices must be positive.";
                if (p<-0.00000001 || p>1.0000001) 
                    return "The edge probability must be between 0.0 and 1.0";
                return null;
        }
}